import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung: Menue - Demo
  *
  * @version 1.0 vom 14.12.2010
  * @author claus albowski
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private JMenuBar jMenuBar = new JMenuBar();                      // <<<-- !
  private JMenu jDateiMenu = new JMenu("Datei");                   // <<<-- !
  private JMenuItem jNeuItem = new JMenuItem("Neu");               // <<<-- !
  private JMenuItem jSpeichernItem = new JMenuItem("Speichern");   // <<<-- !
  private JMenuItem jBeendenItem = new JMenuItem("Beenden");       // <<<-- !
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 167;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    setJMenuBar(jMenuBar);                                 // <<<-- !
    jMenuBar.add(jDateiMenu);                              // <<<-- !
    jDateiMenu.add(jNeuItem);                              // <<<-- !
    jDateiMenu.add(jSpeichernItem);                        // <<<-- !
    jDateiMenu.add(jBeendenItem);                          // <<<-- !
    // dazu Ereignisse definieren:
    jNeuItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        System.out.println("Neu angeklickt");
      }
    });
    jSpeichernItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        System.out.println("Speichern angeklickt");
      }
    });
    jBeendenItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        System.out.println("Beenden angeklickt");
        System.exit(0);
      }
    });
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Menue - Demo");
  }
}
