import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.geom.*;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.EOFException;

/**
  *
  * Beispielprogramm zur Demonstration des
  * Speicherns und Ladens von Objekten.
  *
  * [ ohne Trennung von Modell und Gui ]
  * @version 1.0 vom 13.01.2011
  * @author claus albowski
  */

public class Gui extends JFrame
implements Serializable           // mehr muss nicht sein!
{
  // Anfang Attribute
  private JPanel zeichenflaeche = new Zeichenflaeche();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JButton jButton3 = new JButton();
  private JButton jButton4 = new JButton();
  private JButton jButton5 = new JButton();
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 300;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    zeichenflaeche.setBounds(8, 72, 273, 185);
    cp.add(zeichenflaeche);

    jButton1.setBounds(8, 8, 75, 25);
    jButton1.setText("Rechteck");
    jButton1.setMargin(new Insets(2, 2, 2, 2));
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jButton2.setBounds(8, 40, 75, 25);
    jButton2.setText("Kreis");
    jButton2.setMargin(new Insets(2, 2, 2, 2));
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton2_ActionPerformed(evt);
      }
    });
    cp.add(jButton2);
    jButton3.setBounds(96, 8, 75, 25);
    jButton3.setText("Bogen");
    jButton3.setMargin(new Insets(2, 2, 2, 2));
    jButton3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton3_ActionPerformed(evt);
      }
    });
    cp.add(jButton3);
    jButton4.setBounds(216, 8, 75, 25);
    jButton4.setText("Speichern");
    jButton4.setMargin(new Insets(2, 2, 2, 2));
    jButton4.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton4_ActionPerformed(evt);
      }
    });
    cp.add(jButton4);
    jButton5.setBounds(216, 40, 75, 25);
    jButton5.setText("Laden");
    jButton5.setMargin(new Insets(2, 2, 2, 2));
    jButton5.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton5_ActionPerformed(evt);
      }
    });
    cp.add(jButton5);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jButton1_ActionPerformed(ActionEvent evt) {
    Rectangle2D rechteck = new Rectangle2D.Double(10,10,40,60);
    graphic.draw(rechteck);
    shapes.add(rechteck);
    zeichenflaeche.repaint();
    jButton1.setEnabled(false);
  }

  public void jButton2_ActionPerformed(ActionEvent evt) {
    Ellipse2D kreis = new Ellipse2D.Double(80,30,50,50);
    graphic.draw(kreis);
    shapes.add(kreis);
    zeichenflaeche.repaint();
    jButton2.setEnabled(false);
  }

  public void jButton3_ActionPerformed(ActionEvent evt) {
    Arc2D bogen = new Arc2D.Double(120,80,120,180,30,150,Arc2D.OPEN);
    graphic.draw(bogen);
    shapes.add(bogen);
    zeichenflaeche.repaint();
    jButton3.setEnabled(false);
  }

  public void jButton4_ActionPerformed(ActionEvent evt) {
    graphic.setColor(hintergrundfarbe);
    Dimension size = zeichenflaeche.getSize();
    graphic.fill(new Rectangle(0, 0, size.width, size.height));
    graphic.setColor(Color.black);
    zeichenflaeche.repaint();
    try {sichern();
    } catch (IOException e){System.out.println("Datei existiert nicht!");}
    shapes.clear();
  }

  public void jButton5_ActionPerformed(ActionEvent evt) {
    graphic.setColor(hintergrundfarbe);
    Dimension size = zeichenflaeche.getSize();
    graphic.fill(new Rectangle(0, 0, size.width, size.height));
    graphic.setColor(Color.black);
    zeichenflaeche.repaint();
    shapes.clear();
    try{
      holen();
    } catch (Exception e) {System.out.println("E-Fehler");}
    for (int i=0; i<shapes.size();i++) graphic.draw(shapes.get(i));
    zeichenflaeche.repaint();
  }

  // Ende Methoden
  
  // Abschnitt fuer die Grafik:
  private Graphics2D graphic = null;
  private Color hintergrundfarbe = Color.white;
  private Image leinwandImage;
  private void grafikInit(){
    Dimension size = zeichenflaeche.getSize();
    leinwandImage = zeichenflaeche.createImage(size.width, size.height);
    graphic = (Graphics2D) leinwandImage.getGraphics();
    graphic.setColor(hintergrundfarbe);
    graphic.fillRect(0, 0, size.width, size.height);
    graphic.setColor(Color.black);
  }
  
  // Abschnitt fuer das Speichern und Laden der Objekte
  private ArrayList<Shape> shapes = new ArrayList();
  /**
   * sichern
   */
  private void sichern()
  throws IOException{
      try{
          ObjectOutputStream ausgabe= new ObjectOutputStream(
                new FileOutputStream("ausgabe.obj"));
          for (Shape shape : shapes){
              ausgabe.writeObject(shape);
          }
          ausgabe.close();
      } catch (FileNotFoundException e){
                System.out.println("Datei existiert nicht!"); };
  }
  /**
   * holen
   */
  private void holen()
  throws ClassNotFoundException, IOException{
      try{
          Object o=null;
          shapes = new ArrayList();
          ObjectInputStream eingabe= new ObjectInputStream(
                  new FileInputStream("ausgabe.obj"));
          boolean fertig = false;
          while (!fertig){
              try{
                  o = eingabe.readObject();
              } catch (EOFException eofe) {fertig=true;};
              if (fertig)
              eingabe.close();
              else shapes.add((Shape)o);
          }
      } catch (FileNotFoundException e){
                         System.out.println("Datei existiert nicht!"); };
  }

  /************************************************************************
   * Interne Klasse Zeichenflaeche - die Klasse f�r die GUI-Komponente,
   * die tats�chlich im Leinwand-Fenster angezeigt wird. Diese Klasse
   * definiert ein JPanel mit der zus�tzlichen M�glichkeit, das auf ihm
   * gezeichnet Image aufzufrischen (erneut zu zeichnen).
   */
  private class Zeichenflaeche extends JPanel
  {
    public void paint(Graphics g)
    {
      if (graphic==null) grafikInit();
      g.drawImage(leinwandImage, 0, 0, null);
    }
  }

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
