import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.FileNotFoundException;
import java.io.*;

import java.util.ArrayList;
import java.util.Iterator;

/**
  *
  * Beschreibung: Menue - Demo
  *
  * @version 1.0 vom 14.12.2010
  * @author claus albowski
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private JMenuBar jMenuBar = new JMenuBar();
  private JMenu jDateiMenu = new JMenu("Datei");
  private JMenuItem jNeuItem = new JMenuItem("Neu");
  private JMenuItem jLadenItem = new JMenuItem("Laden");
  private JMenuItem jSpeichernItem = new JMenuItem("Speichern");
  private JMenuItem jAnzeigeItem = new JMenuItem("Anzeigen");
  private JMenuItem jBeendenItem = new JMenuItem("Beenden");
  private JFileChooser jfileChooserRead = new JFileChooser();
  private String dateiName = null;
  private JFileChooser jfileChooserWrite = new JFileChooser();
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 300;
    int frameHeight = 167;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    setJMenuBar(jMenuBar);
    jMenuBar.add(jDateiMenu);
    jDateiMenu.add(jNeuItem);
    jDateiMenu.add(jLadenItem);
    jDateiMenu.add(jSpeichernItem);
    jDateiMenu.add(jAnzeigeItem);
    jDateiMenu.add(jBeendenItem);
    // dazu Ereignisse definieren:
    jNeuItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        neuAktion();
      }
    });
    jLadenItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        LadenAktion();
      }
    });
    jSpeichernItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        SpeichernAktion();
      }
    });
    jAnzeigeItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        AnzeigeAktion();
      }
    });
    jBeendenItem.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        SchliessenAktion();
      }
    });
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  /**
   * neuAktion
   */
  public void neuAktion() {
    System.out.println("Neu angeklickt");
  }
  
  // gehoert hier eigentlich nicht hin, findet man so aber besser:
  private ArrayList<String> text = new ArrayList();
  
  /**
   * LadenAktion
   */
  public void LadenAktion() {
    System.out.println("Laden angeklickt");
    BufferedReader f;
    String zeile;
    dateiName = jfileChooserReadOpenFilename();
    if (dateiName != null)
      try {
        f = new BufferedReader(
              new FileReader(dateiName));
        while ((zeile = f.readLine())!=null) text.add(zeile);
        f.close();
      } catch (IOException e) { JOptionPane.showMessageDialog(this, "E/A-Fehler!"); }
  }
  
  /**
   * SpeichernAktion
   */
  public void SpeichernAktion() {
      System.out.println("Speichern angeklickt");
    BufferedWriter f;
    dateiName = jfileChooserWriteSaveFilename();
    if (dateiName != null)
      try {
        f = new BufferedWriter( new FileWriter(dateiName));
        for (Iterator<String> it= text.iterator(); it.hasNext();) {
          f.write(it.next());
          f.newLine();
        }
        f.close();
      }
      catch (IOException e) { JOptionPane.showMessageDialog(this, "Datei nicht gefunden!"); }
  }
  
  /**
   * SchliessenAktion
   */
  public void SchliessenAktion() {
     System.out.println("Beenden angeklickt");
     if (JOptionPane.showConfirmDialog(this, "wirklich beenden ?", "wirklich beenden ?", JOptionPane.YES_NO_OPTION)
         == JOptionPane.YES_OPTION) System.exit(0);
  }

  public String jfileChooserReadOpenFilename() {
    jfileChooserRead.setDialogTitle("ffne Datei");
    if (jfileChooserRead.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfileChooserRead.getSelectedFile().getPath();
    } else {
      return null;
    }
  }

  public String jfileChooserWriteSaveFilename() {
    jfileChooserWrite.setDialogTitle("Speichere Datei");
    if (jfileChooserWrite.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfileChooserWrite.getSelectedFile().getPath();
    } else {
      return null;
    }
  }
  
  public void AnzeigeAktion(){
    String zeile;
    for (Iterator<String> it= text.iterator(); it.hasNext();){
      System.out.println(it.next());
    }
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Menue - Demo");
  }
}
